initial = dir()

tol = 1e-6

print "===== TEST MAIN EXAMPLES ====="

print
print
print "----- Testing coke.py -----"
import coke

print "+++++ coke.py: Checking Solution Output +++++"
for (l, s) in coke.LOCATIONS_SIZES:
##    print l, s, coke.buildVars[(l, s)].varValue
    if ( (l == "L1") and (s == 150) ) or \
       ( (l == "L2") and (s == 0) ) or \
       ( (l == "L3") and (s == 0) ) or \
       ( (l == "L4") and (s == 0) ) or \
       ( (l == "L5") and (s == 450) ) or \
       ( (l == "L6") and (s == 300) ):
        assert abs(coke.buildVars[(l, s)].varValue - 1.0) < tol, \
               "Bad buildVars[(%s, %s)] value = %g (should be 1.0)" % (l, s, coke.buildVars[(l, s)].varValue)
    else:
        assert abs(coke.buildVars[(l, s)].varValue) < tol, \
               "Bad buildVars[(%s, %s)] value = %g (should be 0.0)" % (l, s, coke.buildVars[(l, s)].varValue)

for m in coke.MINES:
    for l in coke.LOCATIONS:
##        print m, l, coke.CC * coke.flowVars[(m, l)].varValue
        if ( (m == "M1") and (l == "L6") ):
            assert abs(coke.flowVars[(m, l)].varValue - 25.8) < tol, \
               "Bad CC * flowVars[(%s, %s)] value = %g (should be 25.8)" % (m, l, coke.CC * coke.flowVars[(m, l)].varValue)
        elif ( (m == "M2") and (l == "L6") ):
            assert abs(coke.flowVars[(m, l)].varValue - 340.475) < tol, \
               "Bad CC * flowVars[(%s, %s)] value = %g (should be 340.475)" % (m, l, coke.CC * coke.flowVars[(m, l)].varValue)
        elif ( (m == "M3") and (l == "L1") ):
            assert abs(coke.flowVars[(m, l)].varValue - 124.1175) < tol, \
               "Bad CC * flowVars[(%s, %s)] value = %g (should be 124.1175)" % (m, l, coke.CC * coke.flowVars[(m, l)].varValue)
        elif ( (m == "M3") and (l == "L5") ):
            assert abs(coke.flowVars[(m, l)].varValue - 585.0) < tol, \
               "Bad CC * flowVars[(%s, %s)] value = %g (should be 585.0)" % (m, l, coke.CC * coke.flowVars[(m, l)].varValue)
        else:
            assert abs(coke.flowVars[(m, l)].varValue) < tol, \
               "Bad CC * flowVars[(%s, %s)] value = %g (should be 0.0)" % (m, l, coke.CC * coke.flowVars[(m, l)].varValue)
    
for l in coke.LOCATIONS:
    for c in coke.CUSTOMERS:
##        print l, c, coke.flowVars[(l, c)].varValue
        if ( (l == "L1") and (c == "C1") ):
            assert abs(coke.flowVars[(l, c)].varValue - 83.0) < tol, \
               "Bad flowVars[(%s, %s)] value = %g (should be 83.0)" % (l, c, coke.flowVars[(l, c)].varValue)
        elif ( (l == "L1") and (c == "C3") ):
            assert abs(coke.flowVars[(l, c)].varValue - 6.975) < tol, \
               "Bad flowVars[(%s, %s)] value = %g (should be 6.975)" % (l, c, coke.flowVars[(l, c)].varValue)
        elif ( (l == "L1") and (c == "C6") ):
            assert abs(coke.flowVars[(l, c)].varValue - 5.5) < tol, \
               "Bad flowVars[(%s, %s)] value = %g (should be 5.5)" % (l, c, coke.flowVars[(l, c)].varValue)
        elif ( (l == "L5") and (c == "C5") ):
            assert abs(coke.flowVars[(l, c)].varValue - 450.0) < tol, \
               "Bad flowVars[(%s, %s)] value = %g (should be 450.0)" % (l, c, coke.flowVars[(l, c)].varValue)
        elif ( (l == "L6") and (c == "C2") ):
            assert abs(coke.flowVars[(l, c)].varValue - 5.5) < tol, \
               "Bad flowVars[(%s, %s)] value = %g (should be 5.5)" % (l, c, coke.flowVars[(l, c)].varValue)
        elif ( (l == "L6") and (c == "C4") ):
            assert abs(coke.flowVars[(l, c)].varValue - 5.5) < tol, \
               "Bad flowVars[(%s, %s)] value = %g (should be 5.5)" % (l, c, coke.flowVars[(l, c)].varValue)
        elif ( (l == "L6") and (c == "C5") ):
            assert abs(coke.flowVars[(l, c)].varValue - 270.75) < tol, \
               "Bad flowVars[(%s, %s)] value = %g (should be 270.75)" % (l, c, coke.flowVars[(l, c)].varValue)
        else:
            assert abs(coke.flowVars[(l, c)].varValue) < tol, \
               "Bad flowVars[(%s, %s)] value = %g (should be 0.0)" % (l, c, coke.flowVars[(l, c)].varValue)


"""
Build L1 150 (1.0)
Build L2 0 (1.0)
Build L3 0 (1.0)
Build L4 0 (1.0)
Build L5 450 (1.0)
Build L6 300 (1.0)

	L1	 L2	L3	L4	L5	L6
M1 	0.0	 0.0	0.0	0.0	0.0	25.8
M2 	0.0	 0.0	0.0	0.0	0.0	340.475
M3 	124.1175 0.0	0.0	0.0	585.0	0.0
M4 	0.0	 0.0	0.0	0.0	0.0	0.0
M5 	0.0	 0.0	0.0	0.0	0.0	0.0
M6 	0.0	 0.0	0.0	0.0	0.0	0.0

	C1	C2	C3	C4	C5	C6
L1 	83.0	0.0	6.975	0.0	0.0	5.5
L2 	0.0	0.0	0.0	0.0	0.0	0.0
L3 	0.0	0.0	0.0	0.0	0.0	0.0
L4 	0.0	0.0	0.0	0.0	0.0	0.0
L5 	0.0	0.0	0.0	0.0	450.0	0.0
L6 	0.0	5.5	0.0	5.5	270.75	0.0
"""

print "----- coke.py sucessful! -----"

final = dir()

for v in final:
    if v not in initial:
        del v

print
print
print "----- Testing cutting_stock.py -----"
import cutting_stock

print "+++++ cutting_stock.py: Checking Solution Output +++++"
for i, var in cutting_stock.useVars.items():
    if (i == 0) or (i == 1):
        assert abs(var.varValue - 1.0) < tol, \
               "Bad useVars[%s] value = %g (should be 1.0)" % (i, var.varValue)
    else:
        assert abs(var.varValue) < tol, \
               "Bad useVars[%s] value = %g (should be 0.0)" % (i, var.varValue)

for pat in cutting_stock.PATTERNS:
    for i in cutting_stock.ITEMS:
        if (pat == 0) and (i == "5cm"):
            assert abs(cutting_stock.cutVars[(pat, i)].varValue - 2.0) < tol, \
                   "Bad cutVars[(%s, %s)] value = %g (should be 2.0)" % (pat, i, cutting_stock.cutVars[(pat, i)].varValue)
        elif (pat == 0) and (i == "7cm"):
            assert abs(cutting_stock.cutVars[(pat, i)].varValue - 1.0) < tol, \
                   "Bad cutVars[(%s, %s)] value = %g (should be 1.0)" % (pat, i, cutting_stock.cutVars[(pat, i)].varValue)
        elif (pat == 1) and (i == "5cm"):
            assert abs(cutting_stock.cutVars[(pat, i)].varValue - 2.0) < tol, \
                   "Bad cutVars[(%s, %s)] value = %g (should be 2.0)" % (pat, i, cutting_stock.cutVars[(pat, i)].varValue)
        elif (pat == 1) and (i == "9cm"):
            assert abs(cutting_stock.cutVars[(pat, i)].varValue - 1.0) < tol, \
                   "Bad cutVars[(%s, %s)] value = %g (should be 1.0)" % (pat, i, cutting_stock.cutVars[(pat, i)].varValue)
        else:
            assert abs(cutting_stock.cutVars[(pat, i)].varValue) < tol, \
                   "Bad cutVars[(%s, %s)] value = %g (should be 0.0)" % (pat, i, cutting_stock.cutVars[(pat, i)].varValue)

"""
Use 0 1.0
Use 1 1.0
Pat 0 item 5cm 2.0
Pat 0 item 7cm 1.0
Pat 1 item 5cm 2.0
Pat 1 item 9cm 1.0
"""

print "----- cutting_stock.py sucessful! -----"

final = dir()

for v in final:
    if v not in initial:
        del v

print
print
print "----- Testing facility.py -----"
import facility

print "+++++ facility.py: Checking Solution Output +++++"

for i in facility.LOCATIONS:
    if (i == 2) or (i == 4) or (i == 1):
        assert abs(facility.use_vars[i].varValue - 1.0) < tol, \
               "Bad use_vars[%s] value = %g (should be 1.0)" % (i, facility.use_vars[i].varValue)
    else:
        assert abs(facility.use_vars[i].varValue) < tol, \
               "Bad use_vars[%s] value = %g (should be 0.0)" % (i, facility.use_vars[i].varValue)

    for j in facility.PRODUCTS:
        if ( (i == 1) and (j == 2) ) or \
           ( (i == 1) and (j == 5) ) or \
           ( (i == 2) and (j == 1) ) or \
           ( (i == 4) and (j == 3) ) or \
           ( (i == 4) and (j == 4) ):
            assert abs(facility.assign_vars[(i, j)].varValue - 1.0) < tol, \
                   "Bad assign_vars[(%s, %s)] value = %g (should be 1.0)" % (i, j, facility.assign_vars[(i, j)].varValue)
        else:
            assert abs(facility.assign_vars[(i, j)].varValue) < tol, \
                   "Bad assign_vars[(%s, %s)] value = %g (should be 0.0)" % (i, j, facility.assign_vars[(i, j)].varValue)

"""
Location  1  produces  [2, 5]
Location  2  produces  [1]
Location  4  produces  [3, 4]
"""

print "----- facility.py sucessful! -----"

final = dir()

for v in final:
    if v not in initial:
        del v

print
print
print "----- Testing facility_decomp.py -----"
import facility_decomp

print "+++++ facility_decomp.py: Checking Solution Output +++++"

for i in facility_decomp.LOCATIONS:
    if (i == 1) or (i == 3) or (i == 2):
        assert abs(facility_decomp.use_vars[i].varValue - 1.0) < tol, \
               "Bad use_vars[%s] value = %g (should be 1.0)" % (i, facility_decomp.use_vars[i].varValue)
    else:
        assert abs(facility_decomp.use_vars[i].varValue) < tol, \
               "Bad use_vars[%s] value = %g (should be 0.0)" % (i, facility_decomp.use_vars[i].varValue)

    for j in facility_decomp.PRODUCTS:
        if ( (i == 1) and (j == 4) ) or \
           ( (i == 1) and (j == 5) ) or \
           ( (i == 2) and (j == 1) ) or \
           ( (i == 3) and (j == 2) ) or \
           ( (i == 3) and (j == 3) ):
            assert abs(facility_decomp.assign_vars[(i, j)].varValue - 1.0) < tol, \
                   "Bad assign_vars[(%s, %s)] value = %g (should be 1.0)" % (i, j, facility_decomp.assign_vars[(i, j)].varValue)
        else:
            assert abs(facility_decomp.assign_vars[(i, j)].varValue) < tol, \
                   "Bad assign_vars[(%s, %s)] value = %g (should be 0.0)" % (i, j, facility_decomp.assign_vars[(i, j)].varValue)

"""
Location  1  produces  [4, 5]
Location  2  produces  [1]
Location  3  produces  [2, 3]
"""

print "----- facility_decomp.py sucessful! -----"

final = dir()

for v in final:
    if v not in initial:
        del v

print
print
print "----- Testing tsp.py -----"
import tsp

print "+++++ tsp.py: Checking Solution Output +++++"

for arc, var in tsp.arc_vars.items():
    if (arc == (5, 9)) or (arc == (4, 7)) or (arc == (1, 3)) or \
       (arc == (6, 9)) or (arc == (5, 8)) or (arc == (3, 6)) or \
       (arc == (0, 1)) or (arc == (7, 8)) or (arc == (0, 2)) or \
       (arc == (2, 4)):
        assert abs(var.varValue - 1.0) < tol, \
               "Bad arc_vars[%s] value = %g (should be 1.0)" % (arc, var.varValue)
    else:
        assert abs(var.varValue) < tol, \
               "Bad arc_vars[%s] value = %g (should be 0.0)" % (arc, var.varValue)

"""
(5, 9) 1.0
(4, 7) 1.0
(1, 3) 1.0
(6, 9) 1.0
(5, 8) 1.0
(3, 6) 1.0
(0, 1) 1.0
(7, 8) 1.0
(0, 2) 1.0
(2, 4) 1.0
"""

print "----- tsp.py sucessful! -----"
